.TH "CM_EVENT_IO" "3" "May 2003" "" "Red Hat Cluster Manager API Library"
.SH NAME
cm_ev_register, cm_ev_read, cm_ev_free, cm_ev_unregister \- 
Event I/O functions.
.SH SYNOPSIS
.nf
.B #include <clumanager/cm_api.h>
.sp
.BI "int cm_ev_register(int event_class);"
.BI "cm_event_t *cm_ev_read(int fd);"
.BI "void cm_ev_free(cm_event_t *eventp);"
.BI "int cm_ev_unregister(int fd);"
.fi
.SH DESCRIPTION
The \fBcm_ev_register()\fP function connects to the cluster software and
registers for events, returning a file descriptor.  The
.B event_class
may be exactly one of the following:
.LP
.B EC_MEMBERSHIP
\- Membership events.  This only includes membership states, and generally
should not be used by applications which are not part of Red Hat Cluster
Manager.
.LP
.B EC_QUORUM
\- Quorum events.  This includes membership states, but is useful
for applications which require STONITH operations to have been completed
prior to event receipt
.LP
The returned file descriptor may be waited on using the \fBselect(2)\fP
system call.
.LP
The \fBcm_ev_read()\fP function reads an event from the file descriptor
.B fd
and returns the event.
.LP
The \fBcm_ev_free()\fP function frees the data stored in \fBeventp\fP.
.LP
The \fBcm_ev_unregister()\fP function disconnects and cancels registration
on the file descriptor returned by \fBcm_ev_register()\fP.
.SH "RETURN VALUE"
The \fBcm_ev_read()\fP function returns a buffer containing a cluster event
on success or NULL on failure.  The user must free the memory returned with
\fBcm_ev_free()\fP.
The \fBcm_ev_register()\fP function returns a file descriptor on success,
or -1 on failure.
.LP
The \fBcm_ev_unregister()\fP function simply calls \fBclose(2)\fP.
.SH "SEE ALSO"
close(2), select(2), cm_event_data(3)
